<?php

/* * ******************************************************************
 * Version 1.0
 * Modified: 29-08-2015
 * Copyright 2015 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}

if ( !class_exists( 'WPPFM_Db_Management' ) ) :

	/**
	 * The WPPFM_Db_Management Class contains several static database management functions
	 * 
	 * @class WPPFM_Db_Management
	 * @version dev
	 */
	class WPPFM_Db_Management {

		public static function table_exists( $table_name ) {

			global $wpdb;

			if ( $wpdb->get_var( "SHOW TABLES LIKE '" . $table_name . "'" ) === $table_name ) {

				return true;
			} else {

				return false;
			}
		}
		
		/**
		 * makes a copy of a selected feed
		 * 
		 * @param string $feed_id
		 * @return boolean
		 */
		public static function duplicate_feed( $feed_id ) {

			$queries_class = new WPPFM_Queries();
			$support_class = new WPPFM_Feed_Support_Class();
			
			// get the feed data
			$feed_data = $queries_class->get_feed_row( $feed_id  );
			
			// get the meta data
			$meta_data = $queries_class->read_metadata( $feed_id );
			
			// get the category mapping
			$category_mapping = $queries_class->read_category_mapping( $feed_id );

			// generate a new unique feed name
			$feed_data->title = $support_class->next_unique_feed_name( $feed_data->title );
			$feed_data->url = 'No feed generated';
			
			// store a copy of the new feed
			$new_feed_id = $queries_class->insert_feed( $feed_data->channel_id, $feed_data->country_id, 
				$feed_data->source_id, $feed_data->title, $feed_data->main_category, $feed_data->include_variations, 
				$feed_data->is_aggregator, $feed_data->url, $feed_data->status_id, $feed_data->schedule );
			
			$result = $new_feed_id > 0 ? $queries_class->insert_meta_data( $new_feed_id, $meta_data, $category_mapping ) : false;
			
			return $result;
		}

	}

	

endif;
