<?php

/* * ******************************************************************
 * Version 1.2
 * Modified: 07-01-2017
 * Copyright 2017 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}
//
//function wppfm_write_log_file( $error_message, $filename = 'error' ) {
//
//	$log_file = MYPLUGIN_PLUGIN_DIR . $filename . '.log';
//
//	// store the current error messages
//	$buffer = file_exists( $log_file ) ? file_get_contents( $log_file ) : '';
//
//	$new_message = date( "Y-m-d H:i:s" ) . ' - ' . ucfirst($filename) . ' Message: ' . $error_message . PHP_EOL;
//
//	// add the new message on top of the old messages
//	$updated_message = $new_message . $buffer;
//
//	// save the error log to the error log file
//	file_put_contents( $log_file, $updated_message, FILE_APPEND );
//}

/**
 * Converts a string containing a date-time stamp as stored in the meta data to a date time string
 * that can be used in a feed file
 * 
 * @param string $datestamp
 * @return string
 */
function convert_price_date_to_feed_format( $datestamp ) {

	if ( $datestamp ) {
		// register the date
		$feed_string = date( 'Y-m-d', $datestamp );

		// if set, add the time
		if ( date( 'H', $datestamp ) !== '00' || date( 'i', $datestamp ) !== '00' || date( 's', $datestamp ) !== '00' ) {
			$feed_string .= 'T' . date( 'H:i:s', $datestamp );
		}
		
		return $feed_string;
	} else {
		return '';
	}
}

function decrease_updatable_channels() {

	$old = get_option( 'wppfm_channels_to_update' );

	if ( $old > 0 ) { update_option( 'wppfm_channels_to_update', $old - 1 ); } 
	else { update_option( 'wppfm_channels_to_update', 0 ); }
	
	return '1';
}
