<?php

/* * ******************************************************************
 * Version 1.0
 * Modified: 02-10-2016
 * Copyright 2016 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}

if ( !class_exists( 'WPPFM_Add_Options_Page' ) ) :

	class WPPFM_Add_Options_Page extends WPPFM_Admin_Page {

		private $_options_form;
		private $_version_stamp;

		public function __construct() {

			parent::__construct();

			$this->_version_stamp	 = WP_DEBUG ? time() : MYPLUGIN_VERSION_NUM;

			$this->prepare_options_form();
		}

		private function prepare_options_form() {

			$this->_options_form = new WPPFM_Options_Form ();
			
			$this->includes();
		}

		public function show() {

			echo $this->options_page_header();

			echo $this->message_field();

			echo $this->options_page_body();
			
			echo $this->options_page_footer();
		}

		private function options_page_header() {
			
         echo '<div class="wrap">
         <div class="feed-spinner" id="feed-spinner" style="display:none;">
            <img id="img-spinner" src="' . $this->spinner_gif . '" alt="Loading" />
         </div>
         <div class="main-wrapper header-wrapper" id="header-wrapper">
         <div class="header-text"><h1>' . __( 'Feed Manager Settings', 'wppfm-strings' ) . '</h1></div>
         <div class="logo"></div>
		 </div>';
		}
		
		private function options_page_body() {

			$this->_options_form->display();
		}
		
		private function options_page_footer() {
			
			//echo '</div>';
		}
		
		private function includes() {

			wp_localize_script( 'wppfm_data-handling-script', 'MyAjax', array(
				// URL to wp-admin/admin-ajax.php to process the request
				'ajaxurl'			 => admin_url( 'admin-ajax.php' ),
				// generate the nonces
				'setFTPModeNonce'	 => wp_create_nonce( 'myajax-set-ftp-mode-nonce' )
			));
			
			wp_enqueue_script( 'wppfm_data-handling-script', esc_url( MYPLUGIN_PLUGIN_URL . '/includes/data/js/wppfm_ajaxdatahandling.js' ), array( 'jquery' ), $this->_version_stamp );
			wp_enqueue_script( 'wppfm_setting-form-script', esc_url( MYPLUGIN_PLUGIN_URL . '/includes/user-interface/js/wppfm_setting-form.js' ), array( 'jquery' ), $this->_version_stamp );
			wp_enqueue_script( 'wppfm_event-listener-script', esc_url( MYPLUGIN_PLUGIN_URL . '/includes/user-interface/js/wppfm_feed-form-events.js' ), array( 'jquery' ), $this->_version_stamp );
		}
	}	

     // end of WPPFM_Add_Feed_Page class

endif;