<?php

/* * ******************************************************************
 * Version 2.0
 * Modified: 24-12-2015
 * Copyright 2015 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}


if ( !class_exists( 'WPPFM_Feed_Form' ) ) :

	/**
	 * Provides a base class for making standard list tables
	 */
	class WPPFM_Feed_Form {

		/**
		 * Constructor
		 */
		public function __construct() {

		}

		public function display() {

			$html_code = '<div class="meta-box-sortables ui-sortable>';
			$html_code .= '<h3>' . __( 'Basic Feed Options', 'wppfm-strings' ) . '</h3>';

			echo $this->tabs();

			echo $this->add_or_edit_feed_page_code();

			$html_code .= '</div>';

			echo $html_code;
		}

		private function tabs() {

			$html_code = '<h2 class="nav-tab-wrapper">';
			$html_code .= '<a href="admin.php?page=wp-product-feed-manager" class="nav-tab">' . __( 'Feeds List', 'wppfm-strings' ) . '</a>';
			$html_code .= '<a href="admin.php?page=wp-product-feed-manager-add-new-feed\" class="nav-tab nav-tab-active">' . __( 'Add or Edit Feed', 'wppfm-strings' ) . '</a>';
			$html_code .= '</h2>';

			return $html_code;
		}

		private function add_or_edit_feed_page_code() {

			$html_code = '<table class="feed-main-input-table form-table">';
			$html_code .= '<tbody id="feed-data">';
			$html_code .= '<tr><th id="main-feed-input-label"><label for="file-name">' . __( 'File Name', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td><input type="text" name="file-name" id="file-name" /></td></tr>';
			$html_code .= '<tr style="display:none;"><th id="main-feed-input-label"><label for="source-list">' . __( 'Products source', 'wppfm-strings' ) . '</label> :</th>'; // hidden until we support more sources
			$html_code .= '<td>' . WPPFM_Feed_Form_Control::source_selector() . '</td></tr>';
			$html_code .= '<tr><th id="main-feed-input-label"><label for="merchant-list">' . __( 'Channel', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td>' . WPPFM_Feed_Form_Control::channel_selector() . '</td></tr>';
			$html_code .= '<tr id="country-list-row" style="display:none;"><th id="main-feed-input-label"><label for="country-list">' . __( 'Target Country', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td>' . WPPFM_Feed_Form_Control::country_selector() . '</td></tr>';
			$html_code .= '<tr id="category-list-row" style="display:none;"><th id="main-feed-input-label"><label for="categories-list">' . __( 'Default Category', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td>' . WPPFM_Feed_Form_Control::category_selector( "lvl", "-1", true ) . '</td></tr>';
			$html_code .= '<tr id="aggregator-selector-row" style="display:none;"><th id="main-feed-input-label"><label for="aggregator-selector">' . __( 'Aggregator Shop', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td><input type="checkbox" name="aggregator-selector" id="aggregator"></td></tr>';
			$html_code .= '<tr id="add-product-variations-row" style="display:none;"><th id="main-feed-input-label"><label for="product-variations-selector">' . __( 'Include Product Variations', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td><input type="checkbox" name="product-variations-selector" id="variations"></td></tr>';
			$html_code .= '<tr id="update-schedule-row" style="display:none;"><th id="main-feed-input-label"><label for="update-schedule">' . __( 'Update Schedule', 'wppfm-strings' ) . '</label> :</th>';
			$html_code .= '<td>' . WPPFM_Feed_Form_Control::schedule_selector() . '</td></tr>';
			$html_code .= '</tbody>';
			$html_code .= '</table>';
			$html_code .= WPPFM_Feed_Form_Control::category_mapping_table();
			$html_code .= WPPFM_Feed_Form_Control::main_product_filter_wrapper();
			$html_code .= '<section class=master-feed-filter-wrapper></section>';
			$html_code .= '<div class="button-wrapper" id="page-center-buttons">';
			$html_code .= '<input class="button-primary" type="button" name="save" value="' . __( 'Save & Generate Feed' ) . '" id="save-feed-button-top" disabled />';

			$html_code .= '</div>';
			$html_code .= '<div class="widget-content" id="fields-form" style="display:none;">';

			$html_code .= '<section id="attribute-map">';
			$html_code .= '<div class="header" id="fields-form-header"><h3>' . __( 'Attribute Mapping', 'wppfm-strings' ) . ' :</h3></div>';
			$html_code .= '<div id="required-fields" style="display:initial;"><legend class="field-level"><h4>' . __( 'Required', 'wppfm-strings' ) . ':</h4></legend>';
			$html_code .= $this->fieldFormTableTitles();
			$html_code .= '<div class="field-table" id="required-field-table"></div></div>';
			$html_code .= '<div id="highly-recommended-fields" style="display:none;"><legend class="field-level"><h4>' . __( 'Highly recommended', 'wppfm-strings' ) . ':</h4></legend>';
			$html_code .= $this->fieldFormTableTitles();
			$html_code .= '<div class="field-table" id="highly-recommended-field-table"></div></div>';
			$html_code .= '<div id="recommended-fields" style="display:none;"><legend class="field-level"><h4>' . __( 'Recommended', 'wppfm-strings' ) . ':</h4></legend>';
			$html_code .= $this->fieldFormTableTitles();
			$html_code .= '<div class="field-table" id="recommended-field-table"></div></div>';
			$html_code .= '<div id="optional-fields" style="display:initial;"><legend class="field-level"><h4>' . __( 'Optional', 'wppfm-strings' ) . ':</h4></legend>';
			$html_code .= $this->fieldFormTableTitles();
			$html_code .= '<div class="field-table" id="optional-field-table"></div></div>';
			$html_code .= '<div id="custom-fields" style="display:initial;"><legend class="field-level"><h4>' . __( 'Custom attributes', 'wppfm-strings' ) . ':</h4></legend>';
			$html_code .= $this->fieldFormTableTitles();
			$html_code .= '<div class="field-table" id="custom-field-table"></div></div>';
			$html_code .= '</section>';

			$html_code .= '<div class="button-wrapper" id="page-center-buttons">';
			$html_code .= '<input class="button-primary" type="button" name="save" value="' . __( 'Save & Generate Feed' ) . '" id="save-feed-button-bottom" disabled />';
			$html_code .= '</div>';
			$html_code .= '</div>';

			return $html_code;
		}

		private function fieldFormTableTitles() {

			$html_code = '<div class="field-header-wrapper">';
			$html_code .= '<div class="field-header col20w">' . __( 'Add to feed', 'wppfm-strings' ) . '</div>';
			$html_code .= '<div class="field-header col30w">' . __( 'From WooCommerce source', 'wppfm-strings' ) . '</div>';
			$html_code .= '<div class="field-header col40w">' . __( 'Condition', 'wppfm-strings' ) . '</div>';
			$html_code .= '<div class="end-row">&nbsp</div></div>';

			return $html_code;
		}

	}

	

	
    
// end of WPPFM_Feed_Form class

endif;
