<?php

/* * ******************************************************************
 * Version 1.0
 * Modified: 02-10-2016
 * Copyright 2016 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}


if ( !class_exists( 'WPPFM_Options_Form' ) ) :

	/**
	 * Provides a base class for making standard list tables
	 */
	class WPPFM_Options_Form {

		/**
		 * Constructor
		 */
		public function __construct() {

		}

		public function display() {

			$html_code = '<table class="form-table"><tbody>';

			$html_code .= $this->settings();
			
			$html_code .= '</tbody></table>';

			echo $html_code;
		}
		
		private function settings() {

			$option = get_option( 'wppfm_ftp_passive', true );
			$checked = $option === true || $option === 'true' ? ' checked ' : '';
			
			$html_code = '<tr valign="top" class="">';
			$html_code .= '<th scope="row" class="titledesc">FTP Passive Mode</th>';
			$html_code .= '<td class="forminp forminp-checkbox">';
			$html_code .= '<fieldset>';
			$html_code .= '<legend class="screen-reader-text"><span>FTP Passive Mode</span></legend>';
			$html_code .= '<label for="wppfm_ftp_passive_mode">';
			$html_code .= '<input name="wppfm_ftp_passive_mode" id="wppfm_ftp_passive_mode" type="checkbox" class="" value="1"';
			$html_code .= $checked . '> Use FTP Passive Mode when downloading channels (default on). Change this setting when you have trouble downloading a new channel.</label></fieldset>';
			$html_code .= '</td></tr>';
			
			return $html_code;
		}
	}
	
endif;