<?php

/* * ******************************************************************
 * Version 1.1
 * Modified: 02-09-2015
 * Copyright 2015 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}

/**
 * Add the feed manager menu in the Admin page
 */
function wppfm_add_feed_manager_menu( $channel_updated = false ) {

	// defines the feed manager menu
	add_menu_page(
	__( 'WP Feed Manager', 'wppfm-strings' ), __( 'Feed Manager', 'wppfm-strings' ), 'manage_options', 'wp-product-feed-manager', 'wppfm_main_admin_page', esc_url( MYPLUGIN_PLUGIN_URL . '/images/app-rss-plus-xml-icon.png' ) );

	add_submenu_page(
	'wp-product-feed-manager', '', '', 'manage_options', 'wp-product-feed-manager-add-new-feed', 'wppfm_add_feed_page' );
}

add_action( 'admin_menu', 'wppfm_add_feed_manager_menu' );

/**
 * starts the main admin page
 */
function wppfm_main_admin_page() {

	$start = new WPPFM_Main_Admin_Page ();

	// now let's get things going
	$start->show();
}

function wppfm_add_feed_page() {

	$add_new_feed_page = new WPPFM_Add_Feed_Page ();

	$add_new_feed_page->show();
}

/**
 * options page
 */
function wppfm_options_page() {
	
	$add_options_page = new WPPFM_Add_Options_Page ();
	
	$add_options_page->show();
}