<?php

/* * ******************************************************************
 * Version 2.0
 * Modified: 24-12-2016
 * Copyright 2016 Accentio. All rights reserved.
 * License: None
 * By: Michel Jongbloed
 * ****************************************************************** */

// Prevent direct access
if ( !defined( 'ABSPATH' ) ) {
	echo __( 'Hi!  I\'m just a plugin, there\'s not much I can do when called directly.', 'wppfm-strings' );
	exit;
}

function wppfm_show_wp_error( $message, $dismissable = false ) {

	return wppfm_show_wp_message( $message, 'error', $dismissable );
}

function wppfm_show_wp_warning( $message, $dismissable = false ) {

	return wppfm_show_wp_message( $message, 'warning', $dismissable );
}

function wppfm_show_wp_success( $message, $dismissable = false ) {

	return wppfm_show_wp_message( $message, 'success', $dismissable );
}

function wppfm_show_wp_info( $message, $dismissable = false ) {

	return wppfm_show_wp_message( $message, 'info', $dismissable );
}

function wppfm_show_wp_message( $message, $type, $dismissable ) {

	$dism = $dismissable ? ' is-dismissable' : '';
	return '<div class="notice notice-' . $type . $dism . '"><p>'  . $message . '</p></div>';
}

/**
 * enables writing log files in the plugin folder
 * 
 * @param string $error_message
 * @param string $filename
 */
function wppfm_write_log_file( $error_message, $filename = 'error' ) {

	//$log_file = MYPLUGIN_PLUGIN_DIR . $filename . '.log';
	
	$file = fopen( MYPLUGIN_PLUGIN_DIR . $filename . '.log', "a");

	if ( $file ) {
		
		fwrite( $file, date( "Y-m-d H:i:s" ) . ' - ' . ucfirst($filename) . ' Message: ' . $error_message . PHP_EOL );
		
		fclose($file);
	} else {
		
		wppfm_show_wp_error( __("Unable to store an error message in the log file.", 'wppfb-string') );
	}
}

/**
 * allows safe debugging on a operational server of a user
 */
class MJ {

	static function log( $var ) {

		?>
		<style>
			.mj_debug { word-wrap: break-word; white-space: pre; text-align: left; position: relative; 
					   background-color: rgba(0, 0, 0, 0.8); font-size: 11px; color: #a1a1a1; margin: 10px; 
					   padding: 10px; margin: 0 auto; width: 80%; overflow: auto; -moz-box-shadow:0 10px 40px rgba(0, 0, 0, 0.75); 
					   -webkit-box-shadow:0 10px 40px rgba(0, 0, 0, 0.75); -moz-border-radius: 5px; -webkit-border-radius: 5px; text-shadow: none; }
		</style>
		<br /><pre class="mj_debug">

		<?php
		if ( is_null( $var ) || is_string($var) || is_int( $var ) || is_bool($var) || is_float( $var ) ) :
			var_dump( $var );

		else :
			print_r( $var );

		endif;

		echo '</pre><br />';
	}
}